/****************************************************************************

 This file is part of the QGLViewer library
 Copyright (C) 2002, 2003, 2004  Gilles Debunne (Gilles.Debunne@imag.fr)
 Version 1.3.9-2, released on December 3, 2004.

 http://artis.imag.fr/Members/Gilles.Debunne/QGLViewer

 libQGLViewer is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 libQGLViewer is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with libQGLViewer; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*****************************************************************************/

#include <QGLViewer/qglviewer.h>

class Engine
{
public :
  Engine();
  void draw();
  
protected :
  // The axis spinning frame of the conrod
  qglviewer::SpinningFrame axisFrame_;
  qglviewer::SpinningFrame conrodFrame_;
  
private:
  void drawCone(const float zMin,const float zMax, const float r1, const float r2, const float nbSub);
  void drawCylinder(const float zMin,const float zMax, const float r1, const float r2, const float nbSub);
};


class Viewer : public QGLViewer
{
protected :
  virtual void draw();
  virtual void init();  
  virtual QString helpString() const;

private :
  Engine engine;
};
